<script setup>
import { ref, computed } from 'vue';
import ProgBar from 'ui/components/progbar.vue';
import Running from './running.vue';
//import Mood from './items/mood.vue';
import Settings from 'modules/settings';
import { useHidable } from '../composables/use-hidable';
import { useRollOver } from '../../store/popups';

/**
 * Player vital bars.
 */

const props = defineProps(['state']);


const ops = Settings.getSubVars('vitals');
if (!ops.hide) ops.hide = {};

//hide: ops.hide

const elRef = ref();
const btnHides = ref();
const { hides, canShow } = useHidable(btnHides, elRef);

const { itemOver } = useRollOver();

const hp = computed(() => {
	return props.state?.getData('hp');
});

const menaces = computed(() => {
	return props.state?.filterItems(it => it.hasTag('menace') && it.value > 0) ?? []
});

const visMenaces = computed(() => {
	return menaces.value.filter(v => canShow(v))
});

const specials = computed(() => {
	return props.state?.filterItems(it => it.hasTag('specialty') && !it.locked) ?? []
});

const visSpecials = computed(() => { return specials.value.filter(v => canShow(v)) });

const manaList = computed(() => {
	return props.state.filterItems(it => (it.hasTag('manas') || it.hasTag('Mana energies')) && !it.locked)
});

const visMana = computed(() => { return manaList.value.filter(v => canShow(v)) });

const stamina = computed(() => { return props.state?.getData('stamina'); });
const vigor = computed(() => { return props.state?.getData('vigor'); });
</script>

<template>

	<div class="vitals" ref="elRef">

		<Running :runner="state.runner" :state="state" />

		<div class="config"><button ref="btnHides" class="btnConfig"></button></div>

		<!-- anything not a table is a headache -->
		<div class="statbars">

		<div class="hidable statbar" data-key="stamina" v-show="canShow(stamina)">
			<span class="name">stamina</span><span class="barspan">
				<ProgBar class="stamina" :value="stamina.valueOf()" :max="stamina.max.value"
			@mouseenter.capture.stop.native="itemOver($event, stamina)"/>
		</span></div>

		<div class="hidable statbar" data-key="vigor" v-show="canShow(vigor)">
			<span class="name">vigor</span><span class="barspan">
				<ProgBar class="vigor" :value="vigor.valueOf()" :max="vigor.max.value"
			@mouseenter.capture.stop.native="itemOver($event, vigor)"/>
		</span></div>	

		<div class="hidable statbar" data-key="hp" v-show="canShow(hp)"><span class="name">life</span><span class="barspan">
			<ProgBar class="hp" :value="hp.valueOf()" :max="hp.max.value"
			@mouseenter.capture.stop.native="itemOver($event, hp)"/>
		</span></div>

		<div class="hidable statbar" v-for="it in visMana" :key="it.key" :data-key="it.id">
			<span class="name">{{ it.name }}</span><span class="barspan">
				<ProgBar :value="it.valueOf()" :class="it.id" :max="it.max.value" :color="it.color"
			@mouseenter.native.capture.stop="itemOver($event, it)"/>
		</span></div>

		<div class="hidable statbar" v-for="it in visSpecials" :key="it.key" :data-key="it.id">
			<span class="name">{{ it.name }}</span><span class="barspan">
				<ProgBar :value="it.valueOf()" :class="it.id" :max="it.max.value" :color="it.color"
			@mouseenter.native.capture.stop="itemOver($event, it)"/></span></div>

		<div class="hidable statbar" v-for="it in visMenaces" :key="it.key" :data-key="it.id">
			<span class="name">{{ it.name }}</span><span class="barspan">
				<ProgBar :value="it.valueOf()"
					:class="it.id"
					:max="it.max.value" :color="it.color"
					@mouseenter.native.capture.stop="itemOver($event, it)"/>
		</span></div>
		<!--<tr><td>mood</td><td><mood :state="state" /></td></tr>-->
		</div>

	</div>
</template>

<style scoped>
.vitals {
	text-transform: capitalize;
	margin: 0;
	padding: 0;
	min-width: 15rem;
	overflow-y: auto;
	overflow-x: hidden;
}
</style>
